%define ver 295
Summary:	Various compilers (C, C++)
Name: 		gcc%ver
Version: 	2.95.3
Release: 	0
Copyright: 	GPL
Group: 		Development/Languages
Source:       	ftp://ftp.gnu.org/pub/gnu/gcc/gcc-2.95.3.tar.gz
Source1:      	libg++-2.8.1.3.tar.gz
Source2:      	ftp://agnes.dida.physik.uni-essen.de/gnu-pascal/alpha/gpc-20010331.tar.gz
Patch: 		ada.diff
Patch1: 	gcc-accept-doublecolon.diff
Patch2: 	libobjc.diff
Patch10: 	gcc-2.95.2-bogushack-s390x.patch
Patch13: 	gcc-2.95.3-glibc224.patch
URL: 		http://gcc.gnu.org
BuildRoot: 	%{_tmppath}/%{name}-%{version}-buildroot
%ifarch sparc sparc64
Requires: binutils >= 2.9.5.0.46
%else
%ifnarch s390
Requires: binutils >= 2.9.5.0.41
%endif
%endif
%{expand: %%{global} _gcc_is_%{_target_cpu} %%{nil}}
%{?_gcc_is_sparc: %global gcc_target_platform sparc64-redhat-linux}
%{!?_gcc_is_sparc: %global gcc_target_platform %{_target_platform}}
Requires: glibc-devel
#Prereq: /sbin/install-info
ExcludeArch: ia64

%description
The gcc package contains the GNU Compiler Collection: cc and gcc. You'll need
this package in order to compile C/C++ code.

%package c++
Summary: C++ support for gcc
Group: Development/Languages
Requires: %{name} = %{version}-%{release}
#Requires: libstdc++%ver = %{version}-%{release}
#Requires: libstdc++%{ver}-devel = %{version}-%{release}

%description c++
This package adds C++ support to the GNU C compiler. It includes support
for most of the current C++ specification, including templates and
exception handling. It does include the static standard C++
library and C++ header files; the library for dynamically linking
programs is available separately.

%package -n libstdc++%{ver}
Summary: GNU c++ library
Group: System Environment/Libraries
Provides: libstdc++%{ver}-devel
Obsoletes: gcc-libstdc++

%description -n libstdc++%ver
The libstdc++ package contains a snapshot of the GCC Standard C++
Library v3, an ongoing project to implement the ISO 14882 Standard C++
library.

%package objc
Summary: Objective C support for gcc
Group: Development/Languages
Requires: %{name} = %{version}-%{release}

%description objc
gcc-objc provides Objective C support for the GNU C compiler (gcc).
Mainly used on systems running NeXTSTEP, Objective C is an
object-oriented derivative of the C language.

Install gcc-objc if you are going to do Objective C development and
you would like to use the gcc compiler.  You'll also need gcc.

%package g77
Summary: Fortran 77 support for gcc
Group: Development/Languages
Requires: %{name} = %{version}-%{release}

%description g77
The gcc-g77 package provides support for compiling Fortran 77
programs with the GNU gcc compiler.

You should install gcc-g77 if you are going to do Fortran development
and you would like to use the gcc compiler.  You will also need gcc.

%prep

%setup -q -a 1 -a 2 -n gcc-%{version}

rm -rf texinfo
mv libg++-2.8.1.3/* .
mv gpc-20010331/p gcc
rmdir libg++-2.8.1.3 gpc-20010331

%patch
%patch1
%patch2  -p1
%patch10 -p1
%patch13 -p1
cd gcc; patch -p1 < p/diffs/gcc-2.95.2.diff


%build
rm -rf obj-$RPM_ARCH-linux
mkdir obj-$RPM_ARCH-linux
cd obj-$RPM_ARCH-linux

CFLAGS=$RPM_OPT_FLAGS \
../configure  \
	--prefix=/usr \
	--enable-threads \
	--enable-languages=c,c++ \
	--with-gxx-include-dir=%{_includedir}/g++-%{ver} \
	$RPM_ARCH-redhat-linux

PATH=$PATH:/sbin:/usr/sbin
# touch  ../gcc/c-gperf.h
make MAKEINFO="makeinfo --no-split"  bootstrap-lean
# bootstrap

%install
rm -rf $RPM_BUILD_ROOT
cd obj-$RPM_ARCH-linux
PATH=$PATH:/sbin:/usr/sbin
make install \
	prefix=$RPM_BUILD_ROOT%{_prefix} \
	mandir=$RPM_BUILD_ROOT%{_mandir} \
	infodir=$RPM_BUILD_ROOT%{_infodir} \
	gxx_include_dir=$RPM_BUILD_ROOT%{_includedir}/g++-%{ver} \
	MAKEINFO="makeinfo --no-split" 

FULLVER=$($RPM_BUILD_ROOT/usr/bin/gcc --version)
FULLPATH=$(dirname $RPM_BUILD_ROOT/usr/lib/gcc-lib/$RPM_ARCH-*/$FULLVER/cc1)

# fix some things
rm -f $RPM_BUILD_ROOT%{_infodir}/dir

#mkdir -p $RPM_BUILD_ROOT/lib
#ln -sf ../${FULLPATH##$RPM_BUILD_ROOT/}/cpp0 $RPM_BUILD_ROOT/lib/cpp
#ln -sf cccp.1 $RPM_BUILD_ROOT%{_mandir}/man1/cpp.1

# Move libs to gcc-versioned location
(
cd	$RPM_BUILD_ROOT%{_prefix}/lib/gcc-lib/%{_target_cpu}-redhat-linux/%{version}

mv 	$RPM_BUILD_ROOT%{_prefix}/lib/libstdc++.a.* \
	$RPM_BUILD_ROOT%{_prefix}/lib/libg++.a.* \
	$RPM_BUILD_ROOT%{_prefix}/lib/gcc-lib/%{_target_cpu}-redhat-linux/%{version}

rm -f	libg++.a libstdc++.a 
		
ln -sf	libstdc++.a.*	libstdc++.a
ln -sf 	libg++.a.*	libg++.a
)

	

# add Versioning
mv $RPM_BUILD_ROOT%{_prefix}/bin/gcc $RPM_BUILD_ROOT%{_prefix}/bin/gcc%ver
mv $RPM_BUILD_ROOT%{_prefix}/bin/g++ $RPM_BUILD_ROOT%{_prefix}/bin/g++%ver
#mv $RPM_BUILD_ROOT%{_prefix}/bin/g77 $RPM_BUILD_ROOT%{_prefix}/bin/g77-%ver
mv $RPM_BUILD_ROOT%{_prefix}/bin/c++filt $RPM_BUILD_ROOT%{_prefix}/bin/c++%{ver}filt
mv $RPM_BUILD_ROOT%{_mandir}/man1/gcc.1 $RPM_BUILD_ROOT%{_mandir}/man1/gcc%{ver}.1
#mv $RPM_BUILD_ROOT%{_mandir}/man1/cpp.1 $RPM_BUILD_ROOT%{_mandir}/man1/cpp%{ver}.1
mv $RPM_BUILD_ROOT%{_mandir}/man1/g++.1 $RPM_BUILD_ROOT%{_mandir}/man1/g++%{ver}.1
# Wait on this... -Rex
#mv $RPM_BUILD_ROOT%{_includedir}/g++*/* $RPM_BUILD_ROOT%{_prefix}/lib/gcc-lib/%{_target_cpu}-redhat-linux/%{version}/include/

%clean
rm -rf $RPM_BUILD_ROOT

%post -n libstdc++%ver
if ! grep '^%{_prefix}/%{_lib}$' /etc/ld.so.conf > /dev/null 2>&1; then
	echo %{_prefix}/%{_lib} >>/etc/ld.so.conf
fi
/sbin/ldconfig

%postun -n libstdc++%ver
/sbin/ldconfig

%post objc -p /sbin/ldconfig

%postun objc -p /sbin/ldconfig


%files
%defattr(-,root,root)
%doc README* COPYING COPYING.LIB
%dir %{_prefix}/lib/gcc-lib
%dir %{_prefix}/lib/gcc-lib/%{_target_cpu}-redhat-linux/%{version}

%{_prefix}/bin/gcc%ver
#{_infodir}/gcc*
#{_prefix}/bin/protoize
#{_prefix}/bin/unprotoize
#{_prefix}/bin/gcov
#{_prefix}/bin/%{_target_cpu}-redhat-linux-gcc
%{_mandir}/man1/gcc*.1*

%{_prefix}/lib/gcc-lib/%{_target_cpu}-redhat-linux/%{version}/SYSCALLS.c.X
%{_prefix}/lib/gcc-lib/%{_target_cpu}-redhat-linux/%{version}/cc1
%{_prefix}/lib/gcc-lib/%{_target_cpu}-redhat-linux/%{version}/collect2
%{_prefix}/lib/gcc-lib/%{_target_cpu}-redhat-linux/%{version}/libgcc.a
%{_prefix}/lib/gcc-lib/%{_target_cpu}-redhat-linux/%{version}/specs
%{_prefix}/lib/gcc-lib/%{_target_cpu}-redhat-linux/%{version}/*.o

/usr/%{_target_cpu}-redhat-linux

%dir /usr/lib/gcc-lib/%{_target_cpu}-redhat-linux/%{version}/include
/usr/lib/gcc-lib/%{_target_cpu}-redhat-linux/%{version}/include/*
#/usr/lib/gcc-lib/%{_target_cpu}-redhat-linux/%{version}/include/README
#/usr/lib/gcc-lib/%{_target_cpu}-redhat-linux/%{version}/include/float.h
#/usr/lib/gcc-lib/%{_target_cpu}-redhat-linux/%{version}/include/iso646.h
#/usr/lib/gcc-lib/%{_target_cpu}-redhat-linux/%{version}/include/limits.h
#/usr/lib/gcc-lib/%{_target_cpu}-redhat-linux/%{version}/include/proto.h
#/usr/lib/gcc-lib/%{_target_cpu}-redhat-linux/%{version}/include/stdarg.h
#/usr/lib/gcc-lib/%{_target_cpu}-redhat-linux/%{version}/include/stdbool.h
#/usr/lib/gcc-lib/%{_target_cpu}-redhat-linux/%{version}/include/stddef.h
#/usr/lib/gcc-lib/%{_target_cpu}-redhat-linux/%{version}/include/syslimits.h
#/usr/lib/gcc-lib/%{_target_cpu}-redhat-linux/%{version}/include/va-*.h
#/usr/lib/gcc-lib/%{_target_cpu}-redhat-linux/%{version}/include/varargs.h
#{_mandir}/man1/cpp*.1*
#{_mandir}/man1/cccp*.1*
#{_infodir}/cpp.info*
%{_prefix}/lib/gcc-lib/%{_target_cpu}-redhat-linux/%{version}/cpp*

%files c++
%defattr(-,root,root)
%{_mandir}/man1/g++*.1*
%{_prefix}/bin/g++%ver
#{_prefix}/bin/c++%ver
#{_prefix}/bin/c++filt%ver
%{_prefix}/lib/gcc-lib/%{_target_cpu}-redhat-linux/%{version}/cc1plus
%{_prefix}/lib/gcc-lib/%{_target_cpu}-redhat-linux/%{version}/libstdc++.a*
#{_prefix}/lib/gcc-lib/%{_target_cpu}-redhat-linux/%{version}/libstdc++.so*
%{_prefix}/lib/gcc-lib/%{_target_cpu}-redhat-linux/%{version}/libg++.a*
#{_prefix}/lib/gcc-lib/%{_target_cpu}-redhat-linux/%{version}/libg++.so*
%{_prefix}/lib/gcc-lib/%{_target_cpu}-redhat-linux/%{version}/include/exception
%{_prefix}/lib/gcc-lib/%{_target_cpu}-redhat-linux/%{version}/include/new
%{_prefix}/lib/gcc-lib/%{_target_cpu}-redhat-linux/%{version}/include/typeinfo
%{_prefix}/lib/gcc-lib/%{_target_cpu}-redhat-linux/%{version}/include/new.h
%{_includedir}/g+*

%if 0
%files -n libstdc++%ver
%defattr(-,root,root)
%{_prefix}/lib/libstdc++-*

%files objc
%defattr(-,root,root)
%{_prefix}/lib/gcc-lib/%{_target_cpu}-redhat-linux/%{version}/cc1obj
%{_prefix}/lib/gcc-lib/%{_target_cpu}-redhat-linux/%{version}/libobjc.a
%{_prefix}/lib/gcc-lib/%{_target_cpu}-redhat-linux/%{version}/include/objc

%files g77
%defattr(-,root,root)
%{_prefix}/bin/g77-%ver
#{_prefix}/bin/f77
#{_infodir}/g77*
%{_prefix}/lib/gcc-lib/%{_target_cpu}-redhat-linux/%{version}/f771
%{_prefix}/lib/gcc-lib/%{_target_cpu}-redhat-linux/%{version}/libg2c.a
#{_mandir}/man1/g77.1*
#{_mandir}/man1/f77.1*
%{_prefix}/lib/gcc-lib/*-redhat-linux/%{version}/include/g2c.h
%endif

%changelog
* Mon Jul 29 2002 Rex Dieter <rdieter@unl.edu> gcc295-2.95.3-0
- make gcc295 compat compiler, based on gcc-2.95.3 for s390.
- include libg++-2.8.1.3
- drop --enable-shared (for now), so to include only static versions 
  of libstdc++ and libg++.
- c,c++ only (no objc,f77,pascal,java)
- don't deal with info files (for now).

* Mon Jun 10 2002 Phil Knirsch <pknirsch@redhat.com>
- Fixed some wrong file packaging in gcc-c++ and added the correct Requires:
  and Conflicts: to gcc-c++ and libstdc++ packages.

* Mon May 27 2002 Florian La Roche <Florian.LaRoche@redhat.de>
- Added latest official IBM gcc patch (gcc-2.95.3-s390-4).

* Tue Mar 19 2002 Phil Knirsch <pknirsch@redhat.com>
- Added latest official IBM gcc patch (gcc-2.95.3-s390-3).

* Fri Feb 08 2002 Phil Knirsch <pknirsch@redhat.com>
- Reenabled glibc224 patch as we are using glibc 2.2.4 now for 7.1

* Thu Jan 31 2002 David Sainty <dsainty@redhat.com> 2.95.3-0.71.2sx
- add in gcc-2.95.2-bogushack-s390x patch to fix cpp compiles

* Thu Jan 31 2002 David Sainty <dsainty@redhat.com>
- disable glibc224 patch - we don't have glibc-2.2.4 on 7.1

* Wed Oct 24 2001 Karsten Hopp <karsten@redhat.de>
- add -undef patch to ignore unsupported flag

* Tue Oct 16 2001 David Sainty <dsainty@redhat.com>
- use 2.95.3 with following patches:
	- s390 and s390-1 and s390-2 (v.recent) IBM patches
	- glibc224 and libio patches

* Sat Dec 09 2000 Florian La Roche <Florian.LaRoche@redhat.de>
- use 2.95.2 with the following patches:
	- current head of cvs
	- S390 patch from IBM: gcc-2.95.2.4
	- spec file is based on the standard Red Hat Linux 7 one plus
	  a version ported from Red Hat Linux 6.2 to S390 by
		- Oliver Paukstadt <opaukstadt@millenux.com>
		- Fritz Elfert <felfert@to.com>

